<?php
require_once 'products.php';
require_once 'workspace.php';

const MOD_FILE = 'mod.xml';

function safe_unlink($filename) {
    if (file_exists($filename)) {
        unlink($filename);
    }
}

$products = deserialize_catalogues(USER_CATALOGUE_BASE . '/index.xml');
apply_modifications($products, workspace_get(MOD_FILE));

// Può essere un ID della forma <catalogo>/<prodotto> nel caso di un prodotto essitente
// mentre è solo <prodotto> nel caso voglia aggiungere un nuovo prodotto
$id = filter_input(INPUT_GET, 'id', FILTER_SANITIZE_STRING);
$redir = filter_input(INPUT_GET, 'redir', FILTER_SANITIZE_URL);

if (isset($products[$id])) { // rimuovo il prodotto corrente
    $unqualifiedId = $products[$id]->product_id();
    if ($products[$id]->state == Product::ADDED) { // prodotto nuovo => lo rimuovo dal file di modifiche
        unset($products[$id]);
    } else { // prodotto contenuto nel catalogo originale => lo segnalo come da cancellare nel file di modifiche
        $products[$id]->setDeleted();
    }
    // rimuovo le eventuali immagini dalla directory di lavoro
    safe_unlink(workspace_get($unqualifiedId . '.png'));
    safe_unlink(workspace_get($unqualifiedId . '_large.png'));
    generate_mod_file(workspace_get(MOD_FILE), $products);
}

$host = $_SERVER['HTTP_HOST'];
header("Location: http://$host$redir");
