<?php
require_once 'util.php';
require_once 'products.php';
require_once 'workspace.php';

const MOD_FILE = 'mod.xml';

$products = deserialize_catalogues(USER_CATALOGUE_BASE . '/index.xml');
apply_modifications($products, workspace_get(MOD_FILE));

// Può essere un ID della forma <catalogo>/<prodotto> nel caso di un prodotto essitente
// mentre è solo <prodotto> nel caso voglia aggiungere un nuovo prodotto
$id = filter_input(INPUT_POST, 'id', FILTER_SANITIZE_STRING);
$redir = filter_input(INPUT_POST, 'redir', FILTER_SANITIZE_URL);

if (isset($_POST['put'])) { // aggiungo/modifico un prodotto
    if (isset($products[$id])) { // modifico prodotto esistente
        $prod = $products[$id];
        $prod->setModified();
    } else { // aggiungo nuovo prodotto
        $fullId = 'user/' . $id;
        $products[$fullId] = $prod = Product::makeNew($fullId);
    }
    $prod->name = filter_input(INPUT_POST, 'name', FILTER_SANITIZE_STRING);
    $prod->category = filter_input(INPUT_POST, 'category', FILTER_SANITIZE_STRING);
    $prod->description = filter_input(INPUT_POST, 'description', FILTER_SANITIZE_STRING);
    foreach ($_POST['prices'] as $idx => $price) {
        $prod->setPrice($idx, str_to_money($price));
    }
    generate_mod_file(workspace_get(MOD_FILE), $products);
    // sposto le immagini nella directory di lavoro
    if (is_uploaded_file($_FILES['thumbnail']['tmp_name'])) {
        move_uploaded_file($_FILES['thumbnail']['tmp_name'], workspace_get($prod->product_id() . '.png'));
    }
    if (is_uploaded_file($_FILES['image']['tmp_name'])) {
        move_uploaded_file($_FILES['image']['tmp_name'], workspace_get($prod->product_id() . '_large.png'));
    }
}

$host = $_SERVER['HTTP_HOST'];
header("Location: http://$host$redir");
